// wireless.as

/* ---------------- INCLUDE LIBRARIES ------------------- */

#include "MovieClip_extensions.as"
#include "TextField_extensions.as"
#include "color_extensions.as"
#include "easing.as"
#include "Hacker.as"
#include "Answerbox.as"
#include "Buttonbox.as"
#include "event_queue.as"

/* ---------------- DECLARATION ------------------- */

// _root variables

_global.jdgButtonHold = false;
var depthCount = 50;
var attachedMcs = [];
var hiddenBoxMcs = [];
var buttonBlinkRate = 500; //ms
var swfRoot = _root;
var firstPlay = true;

var questionCount = 0;
var questionWrongChances = 3;
var questionOrder = [];
var lastAnswer = false;

var hackerArray = [];
var hackerWiggleInterval = 4000;
var hackerWiggleRandomize = 500;
var hackerOuterDistance = 190;
var hackerInnerDistance = 110;
var hackerStartAngle = 18;

var hackerAngleRandomize = 15;

var hackerTarget = [287,222];

var whichHackerClicked = null;

var pointbase = 100;

var quboxPos = [48,67];

var boxStart = [45, 50];
var boxSpacing = [140, 113];

var continueButtonPos = [168, 275];

var questionTextPadding = 22;
var answerTextPadding = 6;

var answerBoxYSpacing = 8;
var answerBoxIndent = 24;

var soundPlaying = true;
var fadedSoundVolume = 10;
var soundFadeDuration = 31;

// [normal, rollover, dead, correct/selected, incorrect/selected, correct/unselected]
var ansboxBgColors =  [0xb9cce9,0xb9cce9,0xb9cce9,0x5B8F27,0xA4111F,0xb9cce9];
var ansboxOlColors =  [0xffffff,0x1F4270,0xffffff,0xffffff,0xffffff,0xffffff];
var ansboxTextColors = [0x007cba,0x007cba,0xffffff,0xFFFFFF,0xFFFFFF,0xffffff];

// [normal, rollover, dead]
var barbtnBgColors = [0x8ED8F8,0x8ED8F8,0x3789CC];
var barbtnOlColors = [0xFFFFFF,0xFFC20E,0xFFFFFF];
var barbtnTextColors = [0xFFFFFF,0xFFFFFF,0xFFFFFF];

// [normal, rollover, dead]
var contbtnBgColors = [0xFFFFFF,0xFFFFFF,0xFFFFFF];
var contbtnOlColors = [0xBDCCE9,0x005CAC,0xBDCCE9];
var contbtnTextColors = [0x005CAC,0x005CAC,0x005CAC];

var ansboxTf = new TextFormat ();
ansboxTf.align = 'left';
ansboxTf.font = 'f_TheSansBold';
ansboxTf.size = 13;
ansboxTf.color = 0x007cba;

var ansboxBoolTf = new TextFormat ();
ansboxBoolTf.align = 'center';
ansboxBoolTf.font = 'f_TheSansBold';
ansboxBoolTf.size = 13;
ansboxBoolTf.color = 0x007cba;

var questionTf = new TextFormat ();
questionTf.align = 'left';
questionTf.font = 'f_TheSansBold';
questionTf.size = 15;
questionTf.color = 0xffc10e;

var explanationTf= new TextFormat ();
explanationTf.align = 'left';
explanationTf.font = 'f_TheSansBold';
explanationTf.color = 0xffffff;
explanationTf.size = 14;

/* ---------------- SOUNDS ------------------- */

var queuedSound;
var soundLoadQueue = [];
var soundList = [];
loadQueuedSound = function () {
	if (_root.queuedSound.ambient) {
		_root.queuedSound.start (0,1000);
		_root.queuedSound.playing = true;
	}
	if (_root.soundLoadQueue.length > 0) {
		var qs = _root.soundLoadQueue.pop ();
		_root.queuedSound = qs;
		if (qs.external) {
			qs.onLoad = _root.loadQueuedSound;
			qs.loadSound (qs.sourcename);
		} else {
			qs.attachSound (qs.sourcename);
			_root.loadQueuedSound ();
		}
	}
}

// soundList [id, sourcename, external, looping, ambient, fadeVolume]

soundList.push (['rhythm','wireless_pizz_loop.mp3',true,true,true,50]);
soundList.push (['cello','wireless_cello_loop.mp3',true,true,true,0]);
soundList.push (['clarinet','wireless_clarinet_loop.mp3',true,true,true,0]);

soundList.push (['correct', 's_correct', false, false, false, 100]);
soundList.push (['incorrect', 's_incorrect', false, false, false, 100]);
soundList.push (['hackerDie', 's_hackerDie', false, false, false, 100]);
// soundList.push (['question', 's_question', false, false, false]);
soundList.push (['ending', 'wireless_ending.mp3', true, false, false, 100]);

for (var i in soundList) {
	_root['sound_' + soundList[i][0]] = new Sound (_root);
	var sRef = _root['sound_' + soundList[i][0]];
	sRef.sourcename = soundList[i][1];
	sRef.external = soundList[i][2];
	sRef.looping = soundList[i][3];
	sRef.ambient = soundList[i][4];
	sRef.fadeVolume = soundList[i][5];
	_root.soundLoadQueue.push (sRef);
	soundList[i] = sRef;
}

_root.createEmptyMovieClip ('i_soundFader', newMcDepth () );

_root.i_soundFader.fadeSounds = function (dir) { // 'in', 'out'
	this.direction = dir;
	this.fadeSteps = _root.soundFadeDuration;
	this.stepCount = 0;
	this.fadeList = [];
	for (var i in _root.soundList) {
		if (_root.soundList[i].fadeVolume < 100) {
			var tVol = (dir == 'in') ? 100 - _root.soundList[i].fadeVolume : _root.soundList[i].fadeVolume - 100;
			var dVol = (dir == 'in') ? 100 : _root.soundList[i].fadeVolume;
			this.fadeList.push ([_root.soundList[i],_root.soundLIst[i].getVolume (), tVol, dVol]);
		}
	}
	this.onEnterFrame = function () { this.fadeStep () };
}

_root.i_soundFader.fadeStep = function () {
	if (this.stepCount <= this.fadeSteps) {
		for (var i in this.fadeList) {
			var newVol = Math.linearTween (this.stepCount, this.fadeList[i][1], this.fadeList[i][2], this.fadeSteps);
			this.fadeList[i][0].setVolume (newVol);
		}
		this.stepCount ++;
	} else {
		for (var i in this.fadeList) {
			this.fadeList[i][0].setVolume (this.fadeList[i][3]);
		}
		this.onEnterFrame = null;
		delete this.fadeList;
		delete this.stepCount;
		delete this.fadeSteps;
	}
}


/* ---------------- CLASSES ------------------- */

Object.registerClass ('m_smallbtn', Buttonbox);
Object.registerClass ('m_btnClose', Buttonbox);
Object.registerClass ('m_btnReplay', Buttonbox);

/* ---------------- FUNCTIONS ------------------- */

cvtRadians = function (deg) {
	return Math.pi/180 * deg;
}

newMCDepth = function () {
	return depthCount ++;
}

endWait = function () {
	_level0.i_eventQueue.endWait ();
}

returnRandomArray = function (a) {
	var rand, tempArray = [], rtnArray = [];
	tempArray = tempArray.concat (a);
	while (tempArray.length) {
		rand = Math.floor (Math.random () * tempArray.length);
		rtnArray.push (tempArray[rand]);
		tempArray.splice (rand, 1);
	}
	return rtnArray;
}

startGame = function () {
	Mouse.show ();
	if (_root.firstPlay) {
		_root.loadQueuedSound ();
		_root.showBreaker ();
	} else {
		for (var i in _root.attachedMcs) { 
			_root.attachedMcs[i].stop (); 
			_root.attachedMcs[i].onEnterFrame = null; 
			_root.attachedMcs[i].removeMovieClip ();
		}
		_root.attachedMcs = [];
		_level0.i_eventQueue.addWait (2);
		_level0.i_eventQueue.addEvent (_root, 'initMovie', null, false);
		for (var i in _root.soundList) {
			_root.soundList[i].setVolume (100);
		}
	}
}

showBreaker = function () {
	_root.attachNewMc (_root, 'm_scr_intro', 'i_scr_intro');
	_root.i_scr_intro.onRelease = function () { _root.endBreaker (); }
}

endBreaker = function () {
	_level0.i_eventQueue.addEvent (_root.i_scr_intro, 'tweenTo', [[['_alpha',0]],10], true);
	_level0.i_eventQueue.addEvent (_root.i_scr_intro, 'removeMovieClip', null, false);
	_root.buildXML ('wireless_quizdata','quizdata');
}

endGame = function () {
	getURL ('javascript:window.close ();');
}

showOgolPage = function (l) {
	getURL ("http://onguardonline.gov/wireless.html", "_blank");
}

replayGame = function () {
	_root.firstPlay = false;
	startGame ();
}

attachNewMc = function (mc, libname,instname) {
	if (libname != null) {
		mc.attachMovie (libname, instname, newMCDepth () );
	} else {
		mc.createEmptyMovieClip (instname, newMcDepth () );
	}
	_root.attachedMcs.push (_root[instname]);
}

startSoundtrack = function () {
	for (var i in _root.soundList) {
		if (!_root.soundList[i].playing && _root.soundList[i].ambient) {
			_root.soundList[i].start (0,1000);
			_root.soundList[i].playing = true;
		}
	}
	_root.soundPlaying = true;
}

stopSoundtrack = function () {
	for (var i in _root.soundList) {
		_root.soundList[i].stop ();
		_root.soundList[i].playing = false;
	}
	_root.soundPlaying = false;
}

fadeSoundtrack = function () {
	for (var i in _root.soundList) {
		if (_root.soundList[i].fadeVolume != 100) {
			_root.soundList[i].setVolume (_root.soundList[i].fadeVolume);
		}
	}
}

unfadeSoundtrack = function () {
	for (var i in _root.soundList) {
		if (_root.soundList[i].fadeVolume != 100) {
			_root.soundList[i].setVolume (100);
		}
	}
}

toggleSound = function () {
	if (_root.soundPlaying) {
		_root.stopSoundtrack ();
	} else {
		_root.startSoundtrack ();
	}
}

buildXML = function (a,name) {	// create XML object from file
	_root[name] = new XML ();
	_root[name].ignoreWhite = true;
	_root[name].onLoad = _root.xmlloadingDone;
	_root[name].load (a + '.xml');
}

xmlLoadingDone = function (b) {
	initMovie ();
}

// hacker clicked function
hackerClicked = function (h) {
	trace (h._name + ' clicked');
	_root.whichHackerClicked = h;
	_root.showQuestionBg ();
	_level0.i_eventQueue.addEvent (_root, 'showNextQuestion', h, false);
	_root.i_popupInstructions.removeMovieClip ();
	_root.i_popupInstructions2.removeMovieClip ();
}

answerboxClicked = function (box) {
	for (var i in _root.i_qubox.answerMcs) {
		_root.i_qubox.answerMcs[i].kill ();
	}
	_root.i_qubox.i_explanationText.htmlText = box.explanationText;
	_root.i_qubox.i_explanationText.hide ();
	_root.lastAnswer = box.correct;
	if (box.correct) {
		if (_root.soundPlaying) {
			_level0.i_eventQueue.addEvent (_root.sound_correct, 'start', null, false);
		}
	} else {
		if (_root.soundPlaying) {
			_level0.i_eventQueue.addEvent (_root.sound_incorrect, 'start', null, false);
		}
	}
	_root.i_qubox.i_explanationText.setTextFormat (_root.explanationTf);
	_level0.i_eventQueue.addWait (10);
	_level0.i_eventQueue.addEvent (_root.i_qubox.i_explanationText, 'show', null, false);
	_level0.i_eventQueue.addWait (10);
	_level0.i_eventQueue.addEvent (_root.i_qubox.i_buttonContinue, 'show', null, false);
}

continueButtonClicked = function () {
	_root.endQuestion ();
}

updateScoreDisplay = function () {
	_root.i_score.i_questionCounter.nextFrame ();
}

showQuestionBg = function () {
	var startPt = [_root._xmouse, _root._ymouse];
	_root.i_qubox.i_text.htmlText = '';
	_root.i_qubox.movetoA (startPt);
	_root.i_qubox._xscale = 10;
	_root.i_qubox._yscale = 10;
	_root.i_qubox._alpha = 0;
	_root.i_qubox._visible = true;

	var tweenArray = [];
	tweenArray.push (['_x',_root.quboxPos[0]]);
	tweenArray.push (['_y',_root.quboxPos[1]]);
	tweenArray.push (['_xscale',100]);
	tweenArray.push (['_yscale',100]);
	tweenArray.push (['_alpha',100]);

	_root.i_soundFader.fadeSounds ('out');

//  dim hackers
	_level0.i_eventQueue.addEvent (_root, 'dimHackers', null, false);
	_level0.i_eventQueue.addEvent (_root.i_qubox, 'tweenTo', [tweenArray, 10], true);
}

endQuestion = function () {
	_level0.i_eventQueue.addEvent (_root.i_qubox, 'tweenTo', [[['_alpha',0]], 10], true);
	for (var i in _root.i_qubox.answerMcs) {
		_root.i_qubox.answerMcs[i].removeMovieClip ();
	}
	_root.i_qubox.i_questionText.htmlText = '';
	_root.i_qubox.i_explanationText.htmlText = '';
	_root.i_qubox.i_buttonContinue.hide ();
	_level0.i_eventQueue.addEvent (_root.i_qubox, 'hide', null, false);
//	kill hacker on correct answer
	if (_root.lastAnswer) {
		_root.whichHackerClicked.activate ();
		_root.whichHackerClicked.setAlive (false);
		_level0.i_eventQueue.addWait (10);
		if (_root.soundPlaying) {
			_level0.i_eventQueue.addEvent (_root.sound_hackerDie, 'start', null, false);
		}
		_level0.i_eventQueue.addEvent (_root.whichHackerClicked, 'kill', null, false);
		_level0.i_eventQueue.addWait (60);
	}
//
//  questions left?
	if (_root.checkAliveHackers ()) {
		if (_root.questionOrder.length > 0) {
			// advance 'live' hackers
			_level0.i_eventQueue.addEvent (_root, 'updateScoreDisplay', null, false);
			_level0.i_eventQueue.addEvent (_root, 'relightHackers', null, false);
			_level0.i_eventQueue.addEvent (_root.i_soundFader, 'fadeSounds', 'in', false);
		} else {
			_root.showEnding ();
		}
	} else {
		_root.showEnding ();
	}
}

checkAliveHackers = function () {
	for (var i in _root.hackerArray) {
		if (_root.hackerArray[i].getAlive ()) {
			return true;
		}
	}
	return false;
}

showQuestion = function (num) {

	var qNode = _root.quizdata.firstChild.childNodes[num];
	var questionType = qNode.attributes.questionType;
	var ySpace = (questionType == 'boolean') ? _root.answerBoxYSpacing * 2 : _root.answerBoxYSpacing;
	
	var qText = qNode.firstChild.firstChild.nodeValue;
	
	_root.i_qubox.i_questionText.htmlText = qText;
	_root.i_qubox.i_questionText.setTextFormat (_root.questionTf);
	_root.i_qubox.i_questionText._height = _root.i_qubox.i_questionText.textHeight + 6;
	var yCursor = _root.i_qubox.i_questionText._y + _root.i_qubox.i_questionText._height + ySpace;
	
	_level0.i_eventQueue.addEvent (_root.sound_question, 'start', null, false);
	_level0.i_eventQueue.addWait (10);
	
	for (var i = 0; i < qNode.childNodes[1].childNodes.length; i ++) {
		var ansText = qNode.childNodes[1].childNodes[i].firstChild.firstChild.nodeValue;
		var explText = qNode.childNodes[1].childNodes[i].childNodes[1].firstChild.nodeValue;
		var ansCorrect = qNode.childNodes[1].childNodes[i].attributes.correct;

		attachNewMc (_root.i_qubox, 'm_ansbox', 'i_ansbox'+i);
		var o = _root.i_qubox['i_ansbox'+i];
		_root.i_qubox.answerMcs.push (o);
		o.propOnRelease = _root.answerBoxClicked;
		o.bgColors = _root.ansboxBgColors;
		o.olColors = _root.ansboxOlColors;
		if (questionType == 'boolean') {
			o.textFormat = _root.ansboxBoolTf;
		} else {
			o.textFormat = _root.ansboxTf;
		}
		o.textColors = _root.ansboxTextColors;
		o.textPadding = _root.answerTextPadding;
		o.correct = (ansCorrect == "true") ? true : false;
		o.answerText = ansText;
		o.explanationText = explText;
		o._x = _root.answerBoxIndent;
		o._y = yCursor;
		yCursor += o._height + ySpace;
		o._alpha = 0;
		_level0.i_eventQueue.addEvent (o, 'tweenTo', [[['_alpha', 100]], 3], true);
	}
	
	_root.i_qubox.i_explanationText._y = yCursor;
	yCursor += _root.i_qubox.i_explanationText._height + ySpace;
}

dimHackers = function () {
	for (var i in _root.hackerArray) {
		_root.hackerArray[i].deactivate ();
	}
}

lightHackers = function () {
	for (var i in _root.hackerArray) {
		_root.hackerArray[i].activate ();
	}
}

relightHackers = function () {
	_level0.i_eventQueue.addEvent (_root, 'showIqInstructions', null, false);
	for (var i in _root.hackerArray) {
		_root.hackerArray[i].activate ();
		if (_root.hackerArray[i].getAlive ()) {
			var moveVector = _root.hackerArray[i].getMoveVector ();
			var tweenArray = [];
			tweenArray.push (['_x', _root.hackerArray[i]._x + moveVector[0]]);
			tweenArray.push (['_y', _root.hackerArray[i]._y + moveVector[1]]);
			_level0.i_eventQueue.addEvent (_root.hackerArray[i], 'advance', null, false);
			_level0.i_eventQueue.addEvent (_root.hackerArray[i], 'tweenTo', [tweenArray, 30], false);
		}
	}
	_level0.i_eventQueue.addWait (10);
	_level0.i_eventQueue.addEvent (_root.i_ringAnimation, 'gotoAndPlay', 'newQuestion', false);
}

showIqInstructions = function () {
	attachNewMc (_root, 'm_popupInstructions2', 'i_popupInstructions2');
}

showNextQuestion = function () {
	var q = _root.questionOrder.pop ();
	_root.showQuestion (q);
}

showEnding = function () {
	if (!_root.checkAliveHackers ()) {
		var libAsset = 'm_scr_endingWin';
	} else {
		var libAsset = 'm_scr_endingLose';
	}
	
	for (var i in _root.hackerArray) {
		_root.hackerArray[i].endWiggle ();
	}
	
	_root.attachNewMc (_root, libAsset, 'i_scr_ending');
	_root.i_scr_ending._alpha = 0;
	_root.i_scr_ending.hide ();
	_root.i_scr_ending.stop ();
	
	_root.attachNewMc (_root.i_scr_ending, 'm_bgGame', 'i_bgGame');

	_root.attachNewMc (_root.i_scr_ending, 'm_btnReplay', 'i_btnReplay');
	_root.i_scr_ending.i_btnReplay.moveToA ([425,445]);
	_root.i_scr_ending.i_btnReplay.bgColors = _root.barbtnBgColors;
	_root.i_scr_ending.i_btnReplay.olColors = _root.barbtnOlColors;
	_root.i_scr_ending.i_btnReplay.textColors = _root.barbtnTextColors;
	_root.i_scr_ending.i_btnReplay.onRelease = function () { _root.replayGame (); }

	_root.attachNewMc (_root.i_scr_ending, 'm_btnClose', 'i_btnClose');
	_root.i_scr_ending.i_btnClose.moveToA ([507,445]);
	_root.i_scr_ending.i_btnClose.bgColors = _root.barbtnBgColors;
	_root.i_scr_ending.i_btnClose.olColors = _root.barbtnOlColors;
	_root.i_scr_ending.i_btnClose.textColors = _root.barbtnTextColors;
	_root.i_scr_ending.i_btnClose.onRelease = function () { _root.endGame (); }

	if (_root.soundPlaying) {
		_level0.i_eventQueue.addEvent (_root, 'stopSoundtrack', null, false);
		_level0.i_eventQueue.addEvent (_root.sound_ending, 'start', null, false);
		_root.restartSoundOnReplay = true;
	}
	_level0.i_eventQueue.addEvent (_root.i_scr_ending, 'show', null, false);
	_level0.i_eventQueue.addEvent (_root.i_scr_ending, 'tweenTo', [[['_alpha',100]],10], true);
	_level0.i_eventQueue.addEvent (_root.i_scr_ending, 'play', null, false);
}

/* ---------------- MOVIE INITIALIZATION ------------------- */

initMovie = function () {

	_root.i_breaker.removeMovieClip ();
	
	_root.attachNewMc (_root, 'm_ringAnimation', 'i_ringAnimation'); 
	_level0.i_eventQueue.addEvent (_root.i_ringAnimation, 'gotoAndPlay', 'build', false);
	
	_root.questionCount = _root.quizdata.firstChild.childNodes.length;

	_root.questionOrder = [];
	_root.hackerArray = [];

	for (var i=0; i<_root.questionCount; i++) {
		_root.questionOrder.push (i);
	}
	_root.questionOrder = returnRandomArray (_root.questionOrder);

	for (var i=0; i<_root.questionCount - _root.questionWrongChances; i++) {
		_root.attachNewMc (_root, 'm_hackerAnim', 'i_hacker' + i);
		var o = _root['i_hacker' + i];
		o.hide ();
		o.deactivate ();
		o._rotation = (Math.random () - 0.5) * _root.hackerAngleRandomize;
		var oAngle = cvtRadians (360/(_root.questionCount - _root.questionWrongChances) * i + _root.hackerStartAngle);
		var myX = _root.hackerTarget[0] + _root.hackerOuterDistance * Math.cos (oAngle);
		var myY = _root.hackerTarget[1] + _root.hackerOuterDistance * Math.sin (oAngle);
		var myMoveX = ((_root.hackerTarget[0] + _root.hackerInnerDistance * Math.cos (oAngle)) - myX) / (_root.questionCount - _root.questionWrongChances);
		var myMoveY = ((_root.hackerTarget[1] + _root.hackerInnerDistance * Math.sin (oAngle)) - myY) / (_root.questionCount - _root.questionWrongChances);
		o.setMoveVector ([myMoveX, myMoveY]);
		o.propOnRelease = _root.hackerClicked;
		o.moveToA ([myX, myY]);
		
		_root.hackerArray.push (o);
	}
	
	_root.hackerArray = returnRandomArray (_root.hackerArray);
	
	for (var i in _root.hackerArray) {
		var wiggleInt = _root.hackerWiggleInterval + ((Math.random() - 0.5) * 2 * _root.hackerWiggleRandomize);
		_level0.i_eventQueue.addEvent (_root.hackerArray[i], 'show', null, false);
		_level0.i_eventQueue.addEvent (_root.hackerArray[i], 'startWiggle', wiggleInt, false);
		_level0.i_eventQueue.addWait (10);
	}
	
	_level0.i_eventQueue.addEvent (_root, 'lightHackers', null, false);
	
	if (_root.restartSoundOnReplay) {
		_root.startSoundtrack ();
	}

	// draw game board

	_root.attachNewMc (_root, 'm_bgGame', 'i_bgGame');
	_root.attachNewMc (_root, 'm_score', 'i_score');
	_level0.i_eventQueue.addEvent (_root.i_score.i_questionCounter, 'gotoAndStop', 2, false);


	_root.attachNewMc (_root, 'm_b_sound', 'i_buttonSound');
	_root.i_buttonSound.moveToA ([600,445]);
	_root.i_buttonSound.gotoAndStop (_root.soundPlaying ? 1 : 3);
	_root.i_buttonSound.onRelease = function () {
		if (!_global.jdgButtonHold && !this.buttonHold) {
			_root.toggleSound ();
			this.gotoAndStop (_root.soundPlaying ? 1 : 3);
		}
	}
	_root.i_buttonSound.onRollOver = function () {
		if (!_global.jdgButtonHold && !this.buttonHold) {
			this.gotoAndStop (_root.soundPlaying ? 2 : 4);
		}
	}
	_root.i_buttonSound.onRollOut = function () {
		if (!_global.jdgButtonHold && !this.buttonHold) {
			this.gotoAndStop (_root.soundPlaying ? 1 : 3);
		}
	}

	_root.attachNewMc (_root, 'm_popupInstructions', 'i_popupInstructions');
	_root.i_popupInstructions.stop ();
	
	_level0.i_eventQueue.addWait (31);
	_level0.i_eventQueue.addEvent (_root.i_popupInstructions, 'gotoAndPlay', '2', false);
	
	
	// set up question box
	
	_root.attachNewMc (_root, 'm_qubox', 'i_qubox');
	_root.i_qubox._visible = false;
	_root.i_qubox.answerMcs = [];
	
	_root.attachNewMc (_root.i_qubox, 'm_smallbtn', 'i_buttonContinue');
	_root.i_qubox.i_buttonContinue.moveToA (_root.continueButtonPos);
//	_root.i_qubox.i_buttonContinue.__proto__ = Buttonbox.prototype;
	_root.i_qubox.i_buttonContinue.bgColors = _root.contbtnBgColors;
	_root.i_qubox.i_buttonContinue.olColors = _root.contbtnOlColors;
	_root.i_qubox.i_buttonContinue.textColors = _root.contbtnTextColors;
	_root.i_qubox.i_buttonContinue.hide ();
	_root.i_qubox.i_buttonContinue.onRelease = function () { _root.continueButtonClicked (); }

	_root.i_qubox.createTextField ('i_questionText', 1, _root.questionTextPadding, _root.questionTextPadding * .6, _root.i_qubox._width - (_root.questionTextPadding * 2), _root.i_qubox._height * 4);
	var o = _root.i_qubox.i_questionText;
	o.multiline = true;
	o.wordWrap = true;
	o.embedFonts = true;
	o.selectable = false;
	o.html = true;
	o.setNewTextFormat (_root.questionTf);
	
	_root.i_qubox.createTextField ('i_explanationText', 2, _root.questionTextPadding, 480, _root.i_qubox._width - (_root.questionTextPadding * 2), _root.i_qubox._height * 4);
	var p = _root.i_qubox.i_explanationText;
	p.multiline = true;
	p.wordWrap = true;
	p.embedFonts = true;
	p.selectable = false;
	p.html = true;
	p.setNewTextFormat (_root.explanationTf);
	p._visible = false;
	
}


/* ---------------- RUNTIME ------------------- */



if (_root == _level0) { 
	startGame ();
}
